Loading...
Searching...
No Matches
itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions > Class Template Referenceabstract

`#include <itkGPUMatrixOffsetTransformBase.h>`

## Detailed Description

template<typename TScalarType = float, unsigned int NInputDimensions = 3, unsigned int NOutputDimensions = 3>
class itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >

Base version of the GPU MatrixOffsetTransform.

Author
  Denis P. Shamonin and Marius Staring. Division of Image Processing, Department of Radiology, Leiden, The Netherlands

Note
  This work was funded by the Netherlands Organisation for Scientific Research (NWO NRG-2010.02 and NWO 639.021.124).

Definition at line 44 of file itkGPUMatrixOffsetTransformBase.h.

Inheritance diagram for itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >:
[legend]

## Public Types

using | CPUInverseMatrixType = Matrix<TScalarType, Self::InputSpaceDimension, Self::OutputSpaceDimension>
using | CPUMatrixType = Matrix<TScalarType, Self::OutputSpaceDimension, Self::InputSpaceDimension>
using | CPUOutputVectorType = Vector<TScalarType, Self::OutputSpaceDimension>
using | GPUSuperclass = GPUTransformBase
using | ScalarType = TScalarType
using | Self = GPUMatrixOffsetTransformBase
Public Types inherited from itk::GPUTransformBase
using | Self = GPUTransformBase

## Public Member Functions

virtual const char * | GetClassName () const
virtual const CPUMatrixType & | GetCPUMatrix () const =0
virtual const CPUOutputVectorType & | GetCPUOffset () const =0
bool | IsMatrixOffsetTransform () const override
| itkStaticConstMacro (InputSpaceDimension, unsigned int, NInputDimensions)
| itkStaticConstMacro (OutputSpaceDimension, unsigned int, NOutputDimensions)
| itkStaticConstMacro (ParametersDimension, unsigned int, NOutputDimensions *(NInputDimensions+1))
Public Member Functions inherited from itk::GPUTransformBase
virtual const char * | GetNameOfClass () const
virtual GPUDataManager::Pointer | GetParametersDataManager (const std::vcl_size_t index) const
virtual bool | IsBSplineTransform () const
virtual bool | IsIdentityTransform () const
virtual bool | IsTranslationTransform () const

## Protected Member Functions

GPUDataManager::Pointer | GetParametersDataManager () const override
bool | GetSourceCode (std::string &source) const override
| GPUMatrixOffsetTransformBase ()
| ~GPUMatrixOffsetTransformBase () override=default
Protected Member Functions inherited from itk::GPUTransformBase
| GPUTransformBase ()
virtual | ~GPUTransformBase ()=default

## Private Member Functions

| GPUMatrixOffsetTransformBase (const Self &other)=delete
const Self & | operator= (const Self &)=delete

## Private Attributes

std::vector< std::string > | m_Sources {}

## Additional Inherited Members

Protected Attributes inherited from itk::GPUTransformBase
GPUDataManager::Pointer | m_ParametersDataManager {}

## Member Typedef Documentation

## CPUInverseMatrixType

template<typename TScalarType = float, unsigned int NInputDimensions = 3, unsigned int NOutputDimensions = 3>

using itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >::CPUInverseMatrixType = Matrix<TScalarType, Self::InputSpaceDimension, Self::OutputSpaceDimension>

Definition at line 71 of file itkGPUMatrixOffsetTransformBase.h.

## CPUMatrixType

template<typename TScalarType = float, unsigned int NInputDimensions = 3, unsigned int NOutputDimensions = 3>

using itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >::CPUMatrixType = Matrix<TScalarType, Self::OutputSpaceDimension, Self::InputSpaceDimension>

Standard matrix type for this class

Definition at line 70 of file itkGPUMatrixOffsetTransformBase.h.

## CPUOutputVectorType

template<typename TScalarType = float, unsigned int NInputDimensions = 3, unsigned int NOutputDimensions = 3>

using itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >::CPUOutputVectorType = Vector<TScalarType, Self::OutputSpaceDimension>

Definition at line 72 of file itkGPUMatrixOffsetTransformBase.h.

## GPUSuperclass

template<typename TScalarType = float, unsigned int NInputDimensions = 3, unsigned int NOutputDimensions = 3>

using itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >::GPUSuperclass = GPUTransformBase

Definition at line 49 of file itkGPUMatrixOffsetTransformBase.h.

## ScalarType

template<typename TScalarType = float, unsigned int NInputDimensions = 3, unsigned int NOutputDimensions = 3>

using itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >::ScalarType = TScalarType

Type of the scalar representing coordinate and vector elements.

Definition at line 62 of file itkGPUMatrixOffsetTransformBase.h.

## Self

template<typename TScalarType = float, unsigned int NInputDimensions = 3, unsigned int NOutputDimensions = 3>

using itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >::Self = GPUMatrixOffsetTransformBase

Standard typedefs

Definition at line 48 of file itkGPUMatrixOffsetTransformBase.h.

## Constructor & Destructor Documentation

## GPUMatrixOffsetTransformBase() [1/2]

template<typename TScalarType = float, unsigned int NInputDimensions = 3, unsigned int NOutputDimensions = 3>

itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >::GPUMatrixOffsetTransformBase | ( |  | ) |

protected

## ~GPUMatrixOffsetTransformBase()

template<typename TScalarType = float, unsigned int NInputDimensions = 3, unsigned int NOutputDimensions = 3>

itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >::~GPUMatrixOffsetTransformBase | ( |  | ) |

override protected default

## GPUMatrixOffsetTransformBase() [2/2]

template<typename TScalarType = float, unsigned int NInputDimensions = 3, unsigned int NOutputDimensions = 3>

itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >::GPUMatrixOffsetTransformBase | ( | const Self & | other | ) |

private delete

## Member Function Documentation

## GetClassName()

template<typename TScalarType = float, unsigned int NInputDimensions = 3, unsigned int NOutputDimensions = 3>

virtual const char * itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented in itk::GPUAdvancedEuler2DTransform< TScalarType, TParentTransform >, itk::GPUAdvancedEuler3DTransform< TScalarType, TParentTransform >, itk::GPUAdvancedMatrixOffsetTransformBase< TScalarType, NDimensions, TParentTransform >, itk::GPUAdvancedSimilarity2DTransform< TScalarType, TParentTransform >, itk::GPUAdvancedSimilarity3DTransform< TScalarType, TParentTransform >, itk::GPUAffineTransform< TScalarType, NDimensions, TParentTransform >, itk::GPUEuler2DTransform< TScalarType, TParentTransform >, itk::GPUEuler3DTransform< TScalarType, TParentTransform >, itk::GPUSimilarity2DTransform< TScalarType, TParentTransform >, and itk::GPUSimilarity3DTransform< TScalarType, TParentTransform >.

## GetCPUMatrix()

template<typename TScalarType = float, unsigned int NInputDimensions = 3, unsigned int NOutputDimensions = 3>

virtual const CPUMatrixType & itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >::GetCPUMatrix | ( |  | ) | const

pure virtual

Get CPU matrix of an MatrixOffsetTransformBase.

Implemented in itk::GPUAdvancedEuler2DTransform< TScalarType, TParentTransform >, itk::GPUAdvancedEuler3DTransform< TScalarType, TParentTransform >, itk::GPUAdvancedMatrixOffsetTransformBase< TScalarType, NDimensions, TParentTransform >, itk::GPUAdvancedSimilarity2DTransform< TScalarType, TParentTransform >, itk::GPUAdvancedSimilarity3DTransform< TScalarType, TParentTransform >, itk::GPUAffineTransform< TScalarType, NDimensions, TParentTransform >, itk::GPUEuler2DTransform< TScalarType, TParentTransform >, itk::GPUEuler3DTransform< TScalarType, TParentTransform >, itk::GPUSimilarity2DTransform< TScalarType, TParentTransform >, and itk::GPUSimilarity3DTransform< TScalarType, TParentTransform >.

## GetCPUOffset()

template<typename TScalarType = float, unsigned int NInputDimensions = 3, unsigned int NOutputDimensions = 3>

virtual const CPUOutputVectorType & itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >::GetCPUOffset | ( |  | ) | const

pure virtual

Get CPU offset of an MatrixOffsetTransformBase.

Implemented in itk::GPUAdvancedEuler2DTransform< TScalarType, TParentTransform >, itk::GPUAdvancedEuler3DTransform< TScalarType, TParentTransform >, itk::GPUAdvancedMatrixOffsetTransformBase< TScalarType, NDimensions, TParentTransform >, itk::GPUAdvancedSimilarity2DTransform< TScalarType, TParentTransform >, itk::GPUAdvancedSimilarity3DTransform< TScalarType, TParentTransform >, itk::GPUAffineTransform< TScalarType, NDimensions, TParentTransform >, itk::GPUEuler2DTransform< TScalarType, TParentTransform >, itk::GPUEuler3DTransform< TScalarType, TParentTransform >, itk::GPUSimilarity2DTransform< TScalarType, TParentTransform >, and itk::GPUSimilarity3DTransform< TScalarType, TParentTransform >.

## GetParametersDataManager()

template<typename TScalarType = float, unsigned int NInputDimensions = 3, unsigned int NOutputDimensions = 3>

GPUDataManager::Pointer itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >::GetParametersDataManager | ( |  | ) | const

override protected virtual

Returns data manager that stores all settings for the transform.

Reimplemented from itk::GPUTransformBase.

## GetSourceCode()

template<typename TScalarType = float, unsigned int NInputDimensions = 3, unsigned int NOutputDimensions = 3>

bool itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >::GetSourceCode | ( | std::string & | source | ) | const

override protected virtual

Returns OpenCL source code for the transform. Returns true if source code was combined, false otherwise.

Reimplemented from itk::GPUTransformBase.

## IsMatrixOffsetTransform()

template<typename TScalarType = float, unsigned int NInputDimensions = 3, unsigned int NOutputDimensions = 3>

bool itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >::IsMatrixOffsetTransform | ( |  | ) | const

inline override virtual

Reimplemented from itk::GPUTransformBase.

Definition at line 56 of file itkGPUMatrixOffsetTransformBase.h.

## itkStaticConstMacro() [1/3]

template<typename TScalarType = float, unsigned int NInputDimensions = 3, unsigned int NOutputDimensions = 3>

itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >::itkStaticConstMacro | ( | InputSpaceDimension | ,
|  | unsigned int | ,
|  | NInputDimensions | )

Dimension of the domain space.

## itkStaticConstMacro() [2/3]

template<typename TScalarType = float, unsigned int NInputDimensions = 3, unsigned int NOutputDimensions = 3>

itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >::itkStaticConstMacro | ( | OutputSpaceDimension | ,
|  | unsigned int | ,
|  | NOutputDimensions | )

## itkStaticConstMacro() [3/3]

template<typename TScalarType = float, unsigned int NInputDimensions = 3, unsigned int NOutputDimensions = 3>

itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >::itkStaticConstMacro | ( | ParametersDimension | ,
|  | unsigned int | ,
|  | NOutputDimensions * | NInputDimensions+1 )

## operator=()

template<typename TScalarType = float, unsigned int NInputDimensions = 3, unsigned int NOutputDimensions = 3>

const Self & itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >::operator= | ( | const Self & |  | ) |

private delete

## Field Documentation

## m_Sources

template<typename TScalarType = float, unsigned int NInputDimensions = 3, unsigned int NOutputDimensions = 3>

std::vector<std::string> itk::GPUMatrixOffsetTransformBase< TScalarType, NInputDimensions, NOutputDimensions >::m_Sources {}

private

Definition at line 100 of file itkGPUMatrixOffsetTransformBase.h.

Generated on 1768596610 for elastix by 1.15.0 |